

sub cgiAdmDefragment {

if ( $CGI{'go'} ) {

printHead("Defragmenting ...");
print "<pre>";
print &defragment();
print "</pre>";

}
else {

printHead("Defragment table");

( $n, $r, $d, $m ) = &checkIntegrity();

if ($m) {
wbFail( "Cannot defragment", "$m" );
}

$text = <<EOM;
You are about to defragment this table. It has $r records,
$n are old versions that can be removed, $d need to be deleted.
<p>
THE GOOD: This will create a new and more compact versions of
fat.txt and data.txt files in the _data directory.
Less space will be used and the application will work faster.
<p>
THE BAD: Old versions of data will be erased. This will prevent you from undeleting
records or reseting changes.

<form action="$SCRIPT/AdmDefragment">
<input class="BUTTON" type="submit" value="Yes I am">
<input type="hidden" value="1" name="go">
</form>
EOM

$sure = "Are you sure?";    #UK
print &formatWindow( $sure, $text );

}

}


sub checkIntegrity {

open( h, "$DATADIR/_data/fat.txt" )
|| return ( '?', '?', '?', "fat.txt does not exist" );
$r = $n = $d = '0';
while (<h>) {
$r++;
chop;
( $id, $pos ) = split( /\t/, $_ );
if ( $pos{$id} ne '' ) {
$n++;
}
$pos{$id} = $pos;
}
close(h);

@keys = sort { $pos{"$a"} <=> $pos{"$b"} } keys(%pos);

openFile( h, "$DATADIR/_data/records.txt" );

foreach $id (@keys) {
$pos = $pos{$id};

if ( $pos < 0 ) {
$d++;
next;
}

seek( h, $pos, 0 ) || ( $ret .= "Cannot seek $pos for $id\n" );
$meta = <h>;
chop($meta);
( $len, $time ) = split( /\t/, $meta, 2 );
if ( $len =~ /^\d+$/ && $time =~ /^\d+$/ ) {

}
else {
$ret .= "Bad fat entry for $id\n";
}
}
close(h);

return ( $n, $r, $d, $ret );
}


sub openFile {
open( $_[0], $_[1] ) || $_[2] || wbFail("Cannot open $_[1]");
binmode( $_[0] );
}


sub defragment {

openFile( h, "$DATADIR/_data/fat.txt" ) || return "fat.txt does not exist";
flock( h, 2 );
$r = $n = 0;
while (<h>) {
$r++;
chop;
( $id, $pos ) = split( /\t/, $_ );
if ( $pos{$id} ne '' ) {
$n++;
}
$pos{$id} = $pos;
}
close(h);

$ret .= "$r all records, $n obsolete.\n";
if ( $n == 0 ) {
$ret .= "Nothing to do.\n";
return $ret;
}

@keys = sort { $pos{"$a"} <=> $pos{"$b"} } keys(%pos);

openFile( h, "$DATADIR/_data/records.txt" );
flock( h, 2 );
openFile( d, ">$DATADIR/_data/records.wrk" );
openFile( f, ">$DATADIR/_data/fat.wrk" );

foreach $id (@keys) {
$pos = $pos{$id};

next if $pos < 0;    # deleted record

seek( h, $pos, 0 ) || wbFail("Cannot seek $pos for $id");
$meta = <h>;
chop($meta);
( $len, $time ) = split( /\t/, $meta );
read( h, $string, $len ) || wbFail("Cannot read $len from $pos");

$newpos = tell(d);
print d "$meta\n";
print d $string;
print f "$id\t$newpos\n";
}

close(d);
close(f);
close(h);

wbBackupData();

rename( "$DATADIR/_data/fat.wrk", "$DATADIR/_data/fat.txt" )
|| &wbFail("Cannot rename fat.wrk");
rename( "$DATADIR/_data/records.wrk", "$DATADIR/_data/records.txt" )
|| &wbFail("Cannot rename records.wrk");

$ret .= "Defragmented!\n";
return $ret;
}


sub wbBackupData {
local ($file);

$file = "$DATADIR/_data/fat.txt";
if ( -e $file ) {
rename( $file, &wbBackupFile($file) ) || &wbFail("Cannot rename $file");
}
$file = "$DATADIR/_data/records.txt";
if ( -e $file ) {
rename( $file, &wbBackupFile($file) ) || &wbFail("Cannot rename $file");
}
}



sub wbBackupFile {

local ($file) = @_;
local ($add);
@x   = &fixDate(time);
$add = $x[5] . $x[4] . $x[3] . $x[2] . $x[1] . $x[0];
return "$file.at.$add";
}
1;
