

sub cgiAdmMenu {

printHead("Administration menu");

wbCheckDirectories();

print '<div class="MENU"><table><tr><td width="33%" valign="top">';

print &formatMenuTitle("Close/open application");
print &formatMenuItems( "Close application for maintenance", "$SCRIPT/AdmClose", "Open application after maintenance", "$SCRIPT/AdmOpen", );

print &formatMenuTitle("Table definition");
print &formatMenuItems(
"Modify database definition",  "$SCRIPT/AdmModifySettingFrames",
"Apply pageTemplate setting",  "$SCRIPT/AdmApplyPageTemplate",
"Show possible page template", "$SCRIPT/AdmPageTemplate",

"Upgrade CGI definition to dd.txt definition",
"$SCRIPT/AdmSaveDataDict",
"Display definition",         "$SCRIPT/AdmDisplayStructure",
"Display definition (terse)", "$SCRIPT/AdmDisplayStructure?nolegend=1",
"Display errors in definition",
"$SCRIPT/AdmDisplayStructure?nolegend=1&amp;errors=1",
"Display definition as Perl script file", "$SCRIPT/AdmScript",
"Show color scheme",                      "$SCRIPT/ColorSchemeShow",
"Refresh cached HTML",                    "$SCRIPT/AdmTouch",
);

print &formatMenuTitle("Documentation");
print &formatMenuItems(

"Configurable parameters",  "$SCRIPT/AdmConfAttrs",
"Display global variables", "$SCRIPT/AdmPrintVars",
"CGI GUI functions",        "$SCRIPT/AdmPrintCGIAPI",
"Perl API functions",       "$SCRIPT/AdmPrintPerlAPI",
"HTTP API in HTML",         "$SCRIPT/HtmlApi",
"General WSDL",             "$SCRIPT/WSDL",
"Office Research WSDL",     "$SCRIPT/OfficeWSDL",
);

print '</td><td width="33%" valign="top">';

print &formatMenuTitle("Manage users");
print &formatMenuItems(
"Add/delete user",                                "$SCRIPT/AdmModifySetting?type=b&amp;name=groups",
"Delete record's password",                       "$SCRIPT/AdmDelPass",
"Edit rights",                                    "$SCRIPT/AdmModifySetting?type=b&amp;name=rights",
"List registered friends",                        "$SCRIPT/AdmRegisteredPrint",
"Send serial email to addresses of friends",      "$SCRIPT/AdmRegisteredMailForm",
"Send serial email to addresses in the database", "$SCRIPT/AdmMailForm",
);

print &formatMenuTitle("Periodic tasks");
print &formatMenuItems(
"Rebuild fat.txt ...",                                           "$SCRIPT/AdmRebuildFat",
"Defragment data.txt ...",                                       "$SCRIPT/AdmDefragment",
"Clean cache",                                                   "$SCRIPT/AdmClean",
"Reindex",                                                       "$SCRIPT/AdmReindex",
"Index PDF files (slow)(<b>new</b>)",                            "$SCRIPT/AdmIndexPDF",
"Delete expired records",                                        "$SCRIPT/AdmExpireForm",
"Make compiled script",                                          "$SCRIPT/AdmCompile",
"Make TOC for robots",                                           "$SCRIPT/AdmStatic",
"View what should be part of crontab file and save environment", "$SCRIPT/AdmCrons",
"Clean, expire and update static ... all in one go",             "$SCRIPT/AdmDaily",
"Process Agent Requests ...",                                    "$SCRIPT/AdmAgentProcessForm"
);

print &formatMenuTitle("Status");
print &formatMenuItems(
"Log file",        "$SCRIPT/AdmLogfilePrint", "Statistics",      "$SCRIPT/AdmStatistics",
"Database status", "$SCRIPT/AdmWodaStatus",   "Show debug info", "$SCRIPT/AdmDebug",
);

print '</td><td width="33%" valign="top">';

print &formatMenuTitle("Export table");
print &formatMenuItems(
"as CSV comma delimited", "$SCRIPT/AdmExportCSV", "as CSV semicolon delimited", "$SCRIPT/AdmExportCSVS",
"as TAB delimited",       "$SCRIPT/AdmExportTAB", "as OPTION array",            "$SCRIPT/AdmExportID",
"as text files",          "$SCRIPT/AdmExportTextfiles",
);

print &formatMenuTitle("Import data, edit table");
print &formatMenuItems(
"Import from CSV file",                             "$SCRIPT/AdmImportForm",
"Upload userfiles",                                 "$SCRIPT/AdmUploadUserfiles",
"Syncronise userfiles ...",                         "$SCRIPT/AdmSyncUserfilesForm",
"Change a field in many records",                   "$SCRIPT/AdmManySetForm",
"Edit fields in many records",                      "$SCRIPT/AdmManyEditForm",
"Rebuild from default.tbl file (with processing!)", "$SCRIPT/AdmRebuildFromTabForm"
);

print &formatMenuTitle("Backup");
print &formatMenuItems( "Backup table", "$SCRIPT/AdmBackupData", "Restore table ...", "$SCRIPT/AdmRestoreData", );

print &formatMenuTitle("History");
print &formatMenuItems(
"Rollback table ...",                        "$SCRIPT/AdmRollbackForm",
"Rollback, undelete, unchange record ...",   "$SCRIPT/AdmRecordHistoryForm",
"see also history icon on record's toolbar", ''
);

print &formatMenuTitle("Other");
print &formatMenuItems(
"The /<b>Home</b> page of this table", "$SCRIPT/Home", "Try this database as guest", "$SCRIPT/U=guest/",
"Manage raw files (dangerous)",        "$SCRIPT/AdmDir",
);

print "</td></tr></table></div>\n";

print "<H3>Main menu (in case it is hiddent in the app)</H3>\n";

print &formatHomeMenu(4);    # columns

}


sub formatMenuItems {

@stuff = @_;
local ( $text, $url );
local ($r);

$r = '';

for ( $i = 0 ; $i < $#_ ; $i += 2 ) {
$url  = $_[ $i + 1 ];
$text = $_[$i];
$url  = "$SCRIPT/$url" unless ( $url =~ m|^/| || $url =~ m|//| );
next if $url =~ m/$SCRIPT/ && &wbDeniedURL( $Group, $url );
next if $text eq '';

if ($url) {
$r .= "<a href=\"$url\">$text</a><br>\n";
}
else {
$r .= "$text<br>\n";
}
}

$r .= "\n\n";
return $r;
}


sub wbDeniedURL {

local ( $dgroup, $durl ) = @_;
local ( $x1, $x2 );


( $x1, $x2 ) = split( /\?/, $durl, 2 );
$x1 =~ m|/([^/]*)$|;
$durl = $1;

return &wbDenied( $dgroup, $durl );
}


sub formatMenuTitle {

local ( $text, $url ) = @_;
local ($r);

$r = '';
if ($url) {
$r .= "<a href=\"$url\"><b>$text</b></a>:<br>\n";
}
else {
$r .= '<span class="MENUT"><b>' . $text . ':</b></span><br>' . "\n";
}
return $r;

}


sub formatHomeMenu {

local ($cols) = @_;

local ($r);

@ub = split( /\n|\,/, $WBB{'userMenuBrowse'} );
@uf = split( /\n|\,/, $WBB{'userMenuFind'} );
@ud = split( /\n|\,/, $WBB{'userMenuAdd'} );
@ua = split( /\n|\,/, $WBB{'userMenuPersonal'} );
@uo = split( /\n|\,/, $WBB{'userMenuOther'} );

$r = <<'EOM';
<div class="MENU">
<!-- 
Use these to add your own items to menus:
$WBB{'userMenuBrowse'}
$WBB{'userMenuFind'}
$WBB{'userMenuAdd'}
$WBB{'userMenuOther'}
Use $WBB{'rights'} to remove from menus!
-->
EOM

$r .= <<EOM if $cols;
<table width="100%" border="0"><tr><td width="25%" valign="top">
EOM


undef @az;
if ( $WBB{'AZindex'} ) {
@x = split( /\n/, $WBB{'AZindex'} );
foreach $_ (@x) {
local ( $id, $x, $desc ) =
split( /\s+/, $_, 3 );    # make variables my #mf
push( @az, $desc, "$SCRIPT/BrowseAZ?name=$id" );
}
}


undef @fields;
wbBrowseDefaults();
$f = join( ', ', @fields );

if ( $#fields >= 0 ) {
foreach $field (@fields) {
if ( $WBF{ $field, 'typePar' } =~ m/TREE/ ) {
$t = "Hierarchy of '$field'";    #UK
push( @az, $t, "$SCRIPT/BrowseTree?field=$field" );
}
}

$t = "By one keyword";                   #UK
push( @az, $t, "$SCRIPT/BrowseContents" );

$t = "By multiple keywords";             #UK
push( @az, $t, "$SCRIPT/BrowseKeywords" );

}

if ( $#fields >= 1 ) {
$t = "Combinations";                     #UK
push( @az, $t, "$SCRIPT/BrowseMatrixList" );
}


if ( $x = &wbRingField() ) {
$t = "Ring of pages pointed by $x";      #UK
push( @az, $t, "$SCRIPT/BrowseRing" );
}


if ( -s "$DATADIR/_friend/$User.srch" ) {
$t = "Search history";                   #UK
push( @ua, $t, "$SCRIPT/SearchHistory" );    #UK
}

if ( -s "$DATADIR/_friend/$User.forms" ) {
$t = "Saved forms";                          #UK
push( @ua, $t, "$SCRIPT/FormsList" );        #UK
}

if ( -s "$DATADIR/_friend/$User.bskt" ) {
$x = $WBB{'basketName'};
$t = "$x";                                   # e.g. Show shopping list
push( @ua, $t, "$SCRIPT/BasketShow?editable=1" );
}


$x = <<EOM ;                                     #UK
Find
Simple search
What's new
Advanced search
A record by key
EOM
@x = split( /\n/, $x );

$r .= &formatMenuTitle(qq(<img src="$ICONURL/search.gif" $ICONPAR alt="search" title="search"> $x[0]));
$r .= &formatMenuItems( "$x[1]", "$SCRIPT/SearchForm", "$x[2]", "$SCRIPT/NewForm", "$x[3]", "$SCRIPT/AdvancedSearchForm", "$x[4]",
"$SCRIPT/SearchIDForm", @uf );

$r .= '</td><td width="25%" valign="top">' if $cols;


$x = <<EOM ;    #UK
Browse
All records
EOM

@x = split( /\n/, $x );

$r .= &formatMenuTitle(qq(<img alt="browse" src="$ICONURL/browse.gif" $ICONPAR title="browse"> $x[0]));
$r .= &formatMenuItems( @az, @ub, $x[1], "$SCRIPT/Search?", );

$r .= '</td><td width="25%" valign="top">' if $cols;


$x = <<EOM ;    #UK
Add
Add new $WBB{'recordTitle'}
EOM

@x = split( /\n/, $x );
$r .= &formatMenuTitle(qq(<img alt="add" src="$ICONURL/add.gif" $ICONPAR title="add"> $x[0]));
$r .= &formatMenuItems( "$x[1]", "$SCRIPT/Add", @ud );


$x = <<EOM ;    #UK
Personal
View login record
Change password
Login or register
About $User
Database administration
EOM

@x = split( /\n/, $x );

if ( $Group eq 'admin' || $Group eq 'guest' || $Group eq 'friend' ) {
$uicon = "u$Group";
}
else {
$uicon = "uother";
}

$u = &loginRecord();
if ( $u eq '' ) {
$x[1] = '';
$x[2] = '';
$x[3] = '';
}
else {
$cp = $u;
$cp =~ s|/Show|/PassChange|;
$x[3] = 'Logout';
}

$r .= &formatMenuTitle(qq(<img src="$ICONURL/$uicon.gif" $ICONPAR alt="face" title="face"> $x[0]));
$r .= &formatMenuItems( "$x[1]", $u, "$x[2]", $cp, "$x[3]", "$SCRIPT/LoginOrRegister?$Referer",
@ua, "$x[4]", "$SCRIPT/AboutUser", "$x[5]", "$SCRIPT/AdmMenu" );

$r .= '</td><td width="25%" valign="top">' if $cols;

$x = <<EOM ;    #UK
Other
General information
Recent users
Database structure
Office 2003
$POWERTEXT
EOM
@x = split( /\n/, $x );

$r .= &formatMenuTitle(qq(<img src="$ICONURL/info.gif" $ICONPAR alt="info" title=info""> $x[0]));
$r .= &formatMenuItems(
"$x[1]", "$SCRIPT/About",  "$x[2]", "$SCRIPT/FriendsOnline", "$x[3]", "$SCRIPT/DisplayStructure",
"$x[4]", "$SCRIPT/Office", @uo,     "$x[5]",                 "$POWERURL"
);

$r .= '</td></tr></table>' if $cols;
$r .= "</div>\n";
}

sub loginRecord {

local ( $dir, $url, $u );

if ( $WBB{'userTable'} && $Group !~ m/friend|guest|admin/ ) {
$url = &wbTables( 'URL', $WBB{'userTable'} );
$u = &wbFixId($User);

return "$url/Show?_id=$u";
}
else {
return '';
}
}


sub wbRingField {

local ( $urlFld, $field );

wbSortFields();
$urlFld = $WBB{'ringField'};
if ( $urlFld eq '' ) {
foreach $field (@Fields) {
if ( $WBF{ $field, 'type' } eq 'URL' ) {
$urlFld = $field;
last;
}
}
}

return $urlFld;
}


sub wbBrowseDefaults {

wbSortFields();

$inarow = $CGI{'inarow'} || 3;
@fields = split( /,/, $CGI{'fields'} );

if ( $#fields < 0 ) {
foreach $field (@Fields) {
$t = $WBF{ $field, 'type' };
if ( $WBF{ $field, 'type' } =~ m/^OPTION$/ ) {
push( @fields, $field );
}
}
}
}
1;
