

sub cgiAdmMetaTypes {

printHead("Setting types");
foreach $t ( 'c', 's', 'l', 'r', 'x' ) {
push( @n, &admMetaType($t) );
push( @v, &admMetaType( $t, 'LONG' ) );
}

print &formatNameVal( @n, @v );
}


sub formatNameVal {

local ($v0) = ( $#_ + 1 ) / 2;
local ( $i, $out );

return '&nbsp;' if $v0 == 0;    # empty table kills validation

$out = '<table cellspacing="0">' . "\n";
$v   = $v0;
for ( $i = 0 ; $i < $v0 ; $i++ ) {
$out .= qq(<tr valign="top"><th align="right">$_[$i]</th><td>$_[$v]</td></tr>\n);
$v++;
}

$out .= "</table>\n";

return $out;
}


sub admMetaType {

local ( $what, $how ) = @_;

if ( $how ne 'LONG' ) {
return "constant" if $what eq '' || $what eq ' ' || $what eq 'c';
return "string expression"  if $what eq 's';
return "string or constant" if $what eq 'x';
return "logical expression" if $what eq 'l';
return "regular expression" if $what eq 'r';
return "unknown type '$type'";
}
else {
return <<EOM if $what eq '' || $what eq ' ' || $what eq 'c';
A fixed, constant value. Will be printed as is.
EOM
return <<'EOM' if $what eq 's';
A little Perl program, that returns a string:<pre>
"The value of variable thisvariable = $thisvariable"
</pre>
EOM

return <<'EOM' if $what eq 'x';
If it looks like Perl code it will be evaluated,
if not it is taken to be a constant.
EOM

return <<'EOM' if $what eq 'l';
A little Perl program, that returns true (no zero) or false (zero, empty):<pre>
if ($variable > 1000) {
1;
} else {
0;
}
</pre>
EOM
return <<'EOM' if $what eq 'r';
This matches anything starting with a capital letter:<pre>
[A-Z].*
</pre>
EOM

}
}
1;
