

sub cgiAdmPrintVars {

printHead("Global Variables in WODA");
$var = <<'EOM';
$AT::(W) what is UNIX at program
$CHMOD::(W) what is UNIX chmod program
$CRONTAB::(W) where is crontab program
$GREP::(W) where is grep program
$DUMPABLEPERL::(W) where is a dumpable version of Perl
$MV::(W) where is the command to move files
$UNDUMP::where is undump program

$DATADIR::base directory for non HTML related files of this table
$HTMLDIR::base directory for HTML related files of this table

$ADMINPASS::password was ignored, because we are admin
$ADMUSER::reserved
$AF_INET::reserved
$Action::action currently executed
$BIGICONPAR::(W) IMG tags for big icons
$CMDLINE::are we running from command line?
$CRLF::reserved
$CookieGroup::reserved
$CookiePass::reserved
$DIRMODE::(W) in what mode to create directories
$DISK::(W) on WINDOS, on which drive letter is WODA related stuff 
$FILETYPES::for which file types we have extensions
$Group::current group the user belongs to
$HTMLFILE::is output going to a file
$HTTP200OK::(W) add extra HTTPD messages to please some NT servers
$Help::(i)does the user requier a lot of help in forms
$HtmlHeadPrinted::was top of HTML pages printed
$HttpHeadPrinted::(i)was HTTP header printed
$ICONOPEN::reserved
$ICONPAR::(W) standard parameters for IMG tags of icons
$ICONURL::(W) URL of the icons
$WODAURL::(W) URL of various woda related support files
$InFrame::is output going into a frame
$JS::current JavaScript version supported by this browser
$MINIHEAD::print a miniature head only
$MyAction::what would be the name of the overloaded function for this Page
$NOCACHE::reserved
$NOLOGICON::don't display log icon in toolbar
$NO_CRYPT::Perl does not have crypt function
$NO_DIRTIMES::operating system does not show directory modification times
$NO_TIMES::Perl does not have times function
$PDFTOHTML::where is PDFTOHTML program (for swish-e indexing)
$SWISH::where is swish-e (for indexing and searching)
$PERL::where is Perl
$PERLV::version of Perl
$Page::name of the Page requested
$PageCount::number of pages served
$PrintingBasket::are we printing shopping basket
$RGroup::record group
$Referer::the full URL of this page
$ROBOTIP::IP of where robots come from
$ROBOTAGENT::user agent pattern for robots
$SCRIPT::URL of this script, relative to host, including all login data etc. passed on in PATH_INFO
$SCRIPTNAME::like above but without password etc.
$SCRIPTBASE::base host for this script
$SCRIPTURL::full length URL of this script
$SCRIPTFILE::file executed to run this application, can be the code with WBB and WBF definitions or /use$ or /tt$ file that loads a definition
$SCRIPTDIR::directory of SCRIPTFILE
$SCRIPTPACKAGE::in which package is the script
$SOCK_STREAM::reserved
$SENDMAIL::where is sendmail program
$SMTPHOST::address of a machine that can relay email for us 
$SuffixDefault::reserved
$SuffixDetail::reserved
$SuffixSelf::reserved
$TESTCGIDIR::(W)directory to write generated definitions into
$TargetDefault::reserved
$TargetDetail::reserved
$TargetParent::reserved
$TargetSelf::reserved
$ThisRecordNo::record's serial number in search results
$ThisRecordBasket::URL to add this record to basket
$ThisRecordDate::data when this record was modified
$ThisRecordIcons::icons that go with this record
$ThisRecordMatches::how this record matches
$ThisRecordURL::URL of current record
$UNIX::is this a UNIX system ?
$URL::URL of the current page including all login and frams junk
$URLGroup::(before 4.0) group of current user as set in the URL
$LogPass::password of current user as set in the URL or cookies
$User::username of current user
$VALid::reserved
$VERSION::current version of WODA
$WodaPackage::in which Perl package is WODA code 
$WodaFile::name of this script
$WodaFileDir::in which directory is this script
$WodaHelpURL::URL of the WODA help files
$WodaHomeURL::URL of home of WODA
$WodaLanguage::language of messages in this WODA
$WodaLanguageAuthor::who translated WODA to this language
$WodaLibDir::directory with library of subroutines
EOM

@var = split( /\n/, $var );
print <<EOM;
<p>This table lists the global variables that are used
within the WODA engine. Variables marked with (W) are static
setings defined in the WODA code. Some of these variables are
defined at all times, others only during some operations.
<p><b>Within the database definition file, all these variables should
be considered read-only! Information about them is povided for power users
and for debugging purposes.
They are not cast in concrete and their names and values might change
in the future</b></p>

<table border="1">
<tr>
<th>Variable</th>
<th>Description</th>
<th>Current Value</th>
</tr>
EOM

foreach $var (@var) {
( $name, $desc ) = split( /::/, $var, 3 );
$value = &evalSafe("$name");
$value = &htQuote($value);
print <<EOM;
<tr>
<td><b>$name</b></td>
<td>$desc</td>
<td>$value&nbsp;</td>
</tr>
EOM
}
print "</table>\n";
}
1;
