

sub cgiAdmRebuildFromTab {

return unless &saveFormToolbar();

printHead("Rebuilding database from tab file");

open( h, "_cache/default.tbl" ) || wbFail("Open of default.tbl failed");
@records = <h>;    # attn: newlines included !
close(h);

open( h, ">_cache/default.old" );
binmode(h);
print h @records;
close(h);

print "<br>default.tbl backed up to default.old\n";

admRebuild();
}


sub saveFormToolbar {


if ( $CGI{'saveform'} ne '' ) {
delete $CGI{'saveform'};
$CGI{'formdata'} = &hashExport(*CGI);
cgiFormSave();
return 0;    # caller must return too
}


if ( $CGI{'_form'} ) {
$x        = &hashExport(*CGI);
$x        = &htEscape($x);
$Formdata = $x;
push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'FormSave' ) && !$agentFile;
<a href="$SCRIPT/FormSave?formdata=$Formdata"><img $ICONPAR src="$ICONURL/formsave.gif" alt="Save form data" title="Save form data" $TargetParent></a>
EOM
}

return 1;

}


sub cgiFormSave {

printHead("Saving form data");    #UK

$eFormdata = &htQuote( $CGI{'formdata'} );

hashImport( *x, $CGI{'formdata'} );

$x{_formname} = $CGI{'_formname'};

if ( $x{_formname} eq '' ) {

%y = %x;
foreach $key ( keys(%y) ) {
delete $y{$key} if $y{$key} eq '';
}

$h = &formatHash( "Parameters to be saved are:", 1, %y );    #UK

$a = "Define name";                                          #UK
$p = "Save";                                                 #UK
$b = <<EOM;                                                  #UK
<form action="$SCRIPT/FormSave">
Before a form can be saved, it must be named:<br>
<input name="_formname" size="30">
<input type="hidden" name="formdata" value="$eFormdata">
&nbsp;
<input class="BUTTON" type="submit"  value="Save">
</form>
$h
EOM
print &formatWindow( $a, $b );
return;
}
else {
$formdata = &hashExport(*x);


saveFormAppend($formdata);
$dform = $x{_form};

saveFormSavedMessage($dform);
}
}


sub saveFormSavedMessage {

local ($dform) = @_;

print <<EOM;
<p>Form data saved.
<ul>
<li>Here are <a href="$SCRIPT/FormsList?form=$dform">forms related to $dform</a>.
</li><li>Here are <a href="$SCRIPT/FormsList">all forms</a>
</li></ul>
EOM
}


sub saveFormAppend {

local ($formdata) = @_;

open( h, ">>$DATADIR/_friend/$User.forms" );
flock( h, 2 );
binmode(h);
print h "_formid\037" . time . "\037";
print h $formdata;
print h "\n";
close(h);
}


sub hashExport {

local (*hash) = @_;
local ( $key, $val, $out );

$out = '';
foreach $key ( sort( keys(%hash) ) ) {
$val = $hash{$key};

$key =~ tr|\012|\034|;
$val =~ tr|\034| |;      # not 100% simetric!
$val =~ tr|\012|\034|;
$out .= "$key\037$val\037";
}
chop($out);
return $out;
}


sub formatHash {

local ( $name, $quote, @hash ) = @_;
local ( $out, $n, $v, %x );

$out .= <<EOM;
<table>
<tr class="DATAH" >
<th COLSPAN=2>$name</th>
</tr>
EOM

%x = @hash;
foreach $n ( sort( keys(%x) ) ) {
$v = $x{$n};
$v = &htQuote($v) if $quote;
$out .= <<EOM;
<tr class="DATA1" >
<td align="right">$n</td>
<td align="left">&nbsp;$v</td>
</tr>
EOM
}

$out .= <<EOM;
</table>
EOM

undef %x;
return $out;
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}


sub admRebuild {

*fieldNames = &wbReadRecordsFnames();





wbBackupData();

print "<br>Old versions of data backed up!\n";

$todo = $CGI{'action'};
$todo =~ tr/\r//d;

open( H, ">>_tmp/rebuild-actions.txt" );
flock( H, 2 );
binmode(H);
$date = &formatDate(time);
binmode(H);
print H "# --- $date from $RA\n";
print H "$todo\n\n";
close(H);

$| = 1;

print "<br>Actions will be logged to _tmp/rebuild-actions.txt\n";
print "<br>Will do this to each record:<br><pre>$todo</pre>\n\n\n";

$count = 0;
foreach $rec (@records) {
recFromRow( $rec, *fieldNames );
&evalSafe($todo);
if ($@) {
print qq(<p class="ERROR">$id: $@<br>Failed and aborted!\n);
last;
}
$id = $rec{'_id'};
delete $rec{'_id'};

if ( ( $newID = &evalWBBkey() ) ne '' ) {

}
else {

$newID = $id;
}

$rec{'_id'} = $newID;

recWrite() && $count++;
wbRecordChanged();
}

print "<br>$count records written\n";

wbDatabaseChanged();
}


sub wbDatabaseChanged {

if ( $WBB{'afterTableModify'} ne '' ) {
&evalSafe( $WBB{'afterTableModify'} );
}

}


sub wbRecordChanged {

if ( $WBB{'afterRecordModify'} ne '' ) {
&evalSafe( $WBB{'afterRecordModify'} );
}
}


sub evalWBBkey {

local ( $x, $y );

$x = $WBB{'key'};
return '' if $x =~ m/\&NEXT/;

$y = &evalSafe($x);    # setting
return &wbFixId($y);

}


sub wbBackupData {
local ($file);

$file = "$DATADIR/_data/fat.txt";
if ( -e $file ) {
rename( $file, &wbBackupFile($file) ) || &wbFail("Cannot rename $file");
}
$file = "$DATADIR/_data/records.txt";
if ( -e $file ) {
rename( $file, &wbBackupFile($file) ) || &wbFail("Cannot rename $file");
}
}



sub wbBackupFile {

local ($file) = @_;
local ($add);
@x   = &fixDate(time);
$add = $x[5] . $x[4] . $x[3] . $x[2] . $x[1] . $x[0];
return "$file.at.$add";
}
1;
