

sub cgiAdmRebuildFromTabForm {

return unless &saveFormCan('AdmRebuildFromTabForm');

printHead("Rebuild database from TBL file");

if ( &wbExpired( "_cache/default.tbl", "", 0 ) ) {
wbWarn( "Warning!", <<EOM);
The index file, default.tbl, which would be used
to update the raw data is older than the raw data!
If you continue, you may loose recent edits,
but perhaps this is what you want.
EOM
}

print <<EOM;
<p class="WARN">
This will first erase all records and then it will
rebuild them from the _cache/default.tbl file.</p>
$SaveFormForm
<form class="FORM" action="$SCRIPT/AdmRebuildFromTab" method="post">

<p>Processing to apply to each record while rewriting. You should manipulate \$rec{} values.
You can use Perl's <em>next</em> statement to delete some records!
</p>

<p><textarea name="action" cols="60" rows="20">$CGI{'action'}</textarea></p>
<p>$SaveFormButton
<p><input class="BUTTON" type="submit" value="Do it"> It may take time, don't panic!

</p>
</form>
<br>
EOM
}


sub saveFormCan {

local ($caller) = @_;


if ( $CGI{'formdata'} ne '' ) {
hashImport( *CGI, $CGI{'formdata'} );
delete $CGI{'_formid'};
delete $CGI{'_formname'};
delete $CGI{'_form'};
}

if ( $CGI{'listall'} ne '' ) {
cgiFormsList($caller);
return 0;
}

$sfa            = 'Save form as';    #UK
$SaveFormButton = <<EOM;
<input type="hidden" name="_form" value="$caller"><input class="BUTTON" type="submit"  name="saveform" value="$sfa">
<input name="_formname" size="15">
EOM


@rows = &hashRead("$DATADIR/_friend/$User.forms");
@rows = grep( /_form.$caller/, @rows );

if ( $#rows >= 0 ) {

$select = '<option value="">';
foreach $row (@rows) {
hashImport( *x, $row );
if ( $x{_formid} eq $CGI{'select'} ) {
%CGI = %x;
$d   = 'SELECTED';
}
else {
$d = '';
}
$x = $x{_formname};
$select .= qq(<option value="$x{_formid}" $d>$x);
}

$SaveFormForm = <<EOM;
<form class="FORM" action="$SCRIPT/$caller">
Archived forms: <select name="select">
$select
</select>
<input class="BUTTON" type="submit"  value="Load">
<input class="BUTTON" type="submit"  name="listall" value="List all">
</form>
EOM

}
else {

$SaveFormForm = '';

}

return 1;
}


sub cgiFormsList {

$dform = $CGI{'form'};

if ($dform) {
printHead("Saved forms of user $User related to $dform");    #UK
}
else {
printHead("All saved forms of user $User");                  #UK
}

@rows = &hashProcess("$DATADIR/_friend/$User.forms");

print <<EOM;
<p>Click on delete icons to delete archived form.
<p>
EOM


print '<table class="DATATABLE" cellspacing="1">', "\n";

foreach $row (@rows) {
undef %hash;
hashImport( *hash, $row );
next if $dform && $hash{_form} ne $dform;
$id   = $hash{_formid};
$form = $hash{_form};
$name = $hash{_formname};
print <<EOM;
<tr class="DATA0"  valign="top">
<td>
<a href="$SCRIPT/FormsList?delete=$id">
<img $SMALLICONPAR src="$ICONURL/del.gif" alt="Delete this form" title="Delete this form"></a>
</td>
<td align="right">
$form
</td>
<td>
<a href="$SCRIPT/$form?select=$id">$name</a>
</td>
<td>
EOM

foreach $key ( sort( keys(%hash) ) ) {
next if $key =~ m/^_formid|^_form|^_formname|^_confirm/;
$val = $hash{$key};
$val = &htQuote($val);
print "<b>$key</b>=$val\n" if $val;
}

print "</td></tr>\n";

}

print "</table>";
}


sub hashProcess {

local ($file) = @_;

@rows = &hashRead($file);
@rows = &hashDelete(@rows);
hashWrite( $file, *rows );

return @rows;
}


sub hashDelete {

local (@rows) = @_;
local (@out);

foreach $row (@rows) {
$row =~ m/_formid.(\d+)/;
next if $CGI{'delete'} eq $1;
push( @out, $row );
}
return @out;
}


sub hashRead {

local ($file) = @_;
local (@rows);
open( h, $file );
while (<h>) {
chop;
push( @rows, $_ );
}
close(h);

return @rows;
}


sub hashWrite {

local ( $file, *rows ) = @_;
open( h, ">$file" );
binmode(h);
foreach $_ (@rows) {
print h $_ . "\n";
}
close(h);
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}
1;
