

sub cgiBrowseAZ {

$name = $CGI{'name'};

@indexes = split( /\n/, $WBB{'AZindex'} );
@indexes = grep ( /^$name\s/, @indexes );
( $dbname, $fields, $title ) = split( /\s+/, $indexes[0], 3 );

if ( $dbname ne $name || $name eq '' ) {
wbFail("Index '$name' is not defined");    #UK
}

$splitMethod = '';
@indexes     = split( /\n/, $WBB{'AZindexMethod'} );
@indexes     = grep ( /^$name\s/, @indexes );
( $dbname, $splitMethod ) = split( /\s+/, $indexes[0], 2 );
$splitMethod = $splitMethod || 'ASCII,LOWER,SPACE';

$x = "A-Z Index: ";                            #UK
$x .= $title;
printHead($x);

$x = "Index of words in field(s)";             #UK
$x .= " <b>$fields</b>.";

print "<p>$x\n";

( $lcFrom, $lcTo ) = split( / /, $WBB{'intlLower'} );
undef $lcEval;
$lcEval = "tr/$lcFrom/$lcTo/" if $lcFrom;

$wordFname = "_cache/words-$name.txt";
if ( &wbExpired($wordFname) ) {

( $allHits, *list, *fields ) = &recSelect( '', '', '', 'TAB', $fields );

foreach $_ (@list) {

tr/[\000-\040][!-@][\[-`][{-~]/ /s if $splitMethod =~ m/ASCII/;
tr/[A-Z]/[a-z]/                    if $splitMethod =~ m/LOWER|TITLE/;
tr/[a-z]/[A-Z]/                    if $splitMethod =~ m/UPPER/;
@words = split( /\s+/,   $_ ) if $splitMethod =~ m/SPACE/;
@words = split( /\,\s*/, $_ ) if $splitMethod =~ m/COMMA/;
@words = split( /\;\s*/, $_ ) if $splitMethod =~ m/SEMICOLON/;
@words = split( /\:\s*/, $_ ) if $splitMethod =~ m/COLON/;
foreach $word (@words) {
$word = &wbTitleCase($word) if $splitMethod =~ m/TITLE/;
$word = &wbStemWord($word)  if $splitMethod =~ m/STEM/;
$words{$word}++ if $word ne '';
}
}

undef @words;
undef %sort;
( $coFrom, $coTo ) = &wbCollate();
$coEval = "tr/$coFrom/$coTo/" if $coFrom;

@stopWords = split( /\s+/, $WBB{'AZnot'} );
foreach $word ( keys(%words) ) {
next if length($word) == 1;
foreach $stop (@stopWords) {
if ( $word =~ m/^$stop$/i ) {
$words{$word} = 0;
last;
}
}
$_ = $word;
&evalSafe($coEval) if $coEval;
$sort{$word} = $_;

}

@w = keys(%sort);
@words = sort { $sort{$a} cmp $sort{$b} } @w;

open( h, ">$wordFname" ) || wbFail("Cannot write to file $wordFname");
binmode(h);
foreach $word (@words) {
next if $words{$word} == 0;
print h "$word\t$words{$word}\n";
}
close(h);

}

open( h, $wordFname );
@lines = <h>;
close(h);

if ( $CGI{'how'} eq 'frequent' ) {
printAZfrequent( $CGI{'n'} );
}
else {
printAZaz();
}
}


sub printAZaz {

$dletter = '';
foreach $_ (@lines) {
chop;
( $word, $count ) = split(/\t/);
$_ = substr( $word, 0, 1 );
unless (m/[a-z]/) {
&evalSafe($lcEval)
if $lcEval;    # do case lowering & other equivalences
tr/[A-Z]/[a-z]/; # lower case
}
$sword = &htEscape($word);
$entry{$_} .= <<EOM;
<a href="$SCRIPT/Search?search=$sword&amp;paint=1">$word</a> <em>($count)</em>
EOM
if ( $_ ne $dletter ) {
push( @letters, $_ );
$dletter = $_;
}
}


print "<h2><a name=\"az\">\n</a>\n";

foreach $_ (@letters) {
print "<a href=\"#$_\">$_</a>\n";
}

print "</h2>\n\n";

$t = "Browse most frequent.";    #UK
print <<EOM;
<p><a href="$SCRIPT/BrowseAZ?name=$CGI{'name'}&amp;how=frequent">$t</a>
<hr>
EOM

foreach $_ (@letters) {
@items = split( /\n/, $entry{$_} );
$x = &formatColumns( 5, @items );
print <<EOM;

<h2>
<a href=#az><img src="$ICONURL/up.gif" $ICONPAR align="BOTTOM" alt=up title=up></a>
<a name="$_">$_</a>
</h2>
$x
EOM

}
}


sub printAZfrequent {

$maxWords = $CGI{'n'} || 50;

foreach $_ (@lines) {
chop;
( $word, $count ) = split(/\t/);
$_ = $word;

$count{$_} += $count;
}

@words = keys(%count);
@sortedWords = sort { ( ( 999999 - $count{$a} ) . $a ) cmp( ( 999999 - $count{$b} ) . $b ) } @words;

if ( $#sortedWords + 1 < $maxWords ) {
$maxWords = $#sortedWords + 1;
}

print "<h2>Most frequent $maxWords words</h2><ol>";

undef @items;
for ( $i = 0 ; $i < $maxWords ; $i++ ) {
$word  = $sortedWords[$i];
$sword = &htEscape($word);
$count = $count{$word};
print <<EOM;
<li><a href="$SCRIPT/Search?search=$sword">$word</a> <em>($count)</em></li>
EOM
}

print "\n</ol>\n";
}


sub wbStemWord {


local ($_) = @_;

return $_ if s/ing$/\*/;
return $_ if s/ed$/\*/;
return $_ if s/s$/\*/;

}


sub wbTitleCase {

local ($_) = @_;
local ($x);

tr/[A-Z]/[a-z]/;
m/(.)(.*)/;
$x = $1;
$x =~ tr/[a-z]/[A-Z]/;
return $x . $2;
}
1;
