

sub cgiBrowseKeywords {

wbBrowseDefaults();
$f = join( ', ', @fields );

printHead("Browse by keywords in fields $f");    #UK

print <<EOM;                                     #UK
<p>Check any keywords you are interested in then press the
search button at the end of this page. The items with more matched
keywords will be listed on top <b>or</b></p>
<p>Click on keywords next to the checkboxes to search for records
belonging to that category only.</p>
EOM
print <<EOM;
<form class="FORM" method="post" action="$SCRIPT/Search">
EOM

@items   = '';
$dItem   = 0;
$dSearch = '';

foreach $field (@fields) {

if ( $WBF{ $field, typePar } =~ m/HEADING=(.{1,5})/i ) {    # check if the field contains HEADING
$heading = $1;
}
else {
$heading = '';
}

$dSearch = 0;                                               # reset position of label in @optionText;
$head    = &formatFieldName($field);
@kwords  = &wbParseOptions($field);
my @optText = @optionText;                                  # prepare human readable display
$print = "<b>$head</b><br />\n";

foreach $kword (@kwords) {

if ( $heading && $kword =~ m/^$heading/ ) {             # if it is a HEADING value print it
$print .= "<p><i>$kword</i><br>";
$dSearch++;                                         # skip HEADING for labels
next;
}

$x = &wbOptionWordSearch( $field, $kword );
$s = $optionText[$dSearch] || $kword;                   # makes human readable display
$print .= <<EOM;
<input type="checkbox" name="search" value="&quot;$kword&quot;">
<a href="$SCRIPT/Search?search=$x">$s</a><br>
EOM
$dSearch++;
}

$items[ $dItem++ ] = $print;
}

print '<table cellspacing="0">';

for ( $i = 0 ; $i <= $#items ; $i += $inarow ) {
print '<tr valign="top">', "\n";
for ( $j = 0 ; $j < $inarow ; $j++ ) {
$idx = $i + $j;
print <<EOM;
<td>
$items[$idx]
</td>
EOM
}
print "</tr>\n";
}

$search = "S e a r c h";    #UK
$reset  = "R e s e t";      #UK

print <<EOM;
</table>
<p><br>
<input class="BUTTON" type="submit" value="   $search   ">
<input class="BUTTON" type="reset" value="   $reset   ">
</form>
EOM

}


sub wbOptionWordSearch {

local ( $field, $word ) = @_;

$word =~ s|[/()]|\\$&|g;    # escape ( ) and / in search words
return &htEscape("+$field:\"$word\"");
}


sub wbBrowseDefaults {

wbSortFields();

$inarow = $CGI{'inarow'} || 3;
@fields = split( /,/, $CGI{'fields'} );

if ( $#fields < 0 ) {
foreach $field (@Fields) {
$t = $WBF{ $field, 'type' };
if ( $WBF{ $field, 'type' } =~ m/^OPTION$/ ) {
push( @fields, $field );
}
}
}
}
1;
