

sub cgiFullTextSearch {

printHead("Search in full text (experimental)");    #UK

wbFail( "Not available", $SWISH ) unless &canFullTextSearch();    #UK

$search = $CGI{'search'};

$x = "Search full text for:";                                     #UK
$y = "Search";                                                    #UK
$m = "Search in metadata";                                        #UK
$s = &htQuote($search);
$h = <<EOM;                                                       #UK
<p><b>Help:</b>
<ul>
<li> foo bar ... finds documents with foo AND bar
</li><li> foo or bar ... finds documents with foo OR bar
</li><li> foo not bar ... finds documents with foo but NOT with bar
</li></ul>
EOM

print <<EOM;
<form action="$SCRIPT/FullTextSearch" name="searchForm">
<table class="SEARCHBOX" cellspacing="0" width="100%">
<tr><td>
$x
<input name="search" value="$s">
<input class="BUTTON" type="submit"  value="$y">
</td></tr>
</table>
</form>
$h
<a href="$SCRIPT/Search?search=$s">$m</a>
EOM

return unless $search;

if ( $search =~ m/[<>{}|;:]/ ) {
wbError("Bad character in search expression");
return;
}

$search =~ s/\W/\\$&/g;

$x = qq($SWISH -f $DATADIR/_swish/index -H 0 -x "%r %p\\n" -w $search);
$Log .= "Exec $x\n";

@results = `$x`;

$Log .= join( '', @results );

foreach $result (@results) {
chop($result);
( $rank, $file ) = split( / /, $result );
$file =~ m|([^/]*)\.html$|;
$file = $1;
$file =~ m/^[^\.]*/;
push( @ids, $& ) unless $have{$&};
$have{$&} = 1;
}

printRecords( 'DEFAULT', *ids, $#ids );
}


sub canFullTextSearch {

return ( -x $SWISH && -s "$DATADIR/_swish/index" );

}


sub printRecords {

local ( $format, *ids, $max ) = @_;

$max = $max | 10;

undef @list;
wbSortFields();

$i = 0;
foreach $id (@ids) {
recRead($id);
next unless $rec{'_id'};
$i++;
$ThisRecordNo = $i;
$list[$i] = &formatFoundRec( $format, *PFields );    # Hidden ??
last if $i eq $max;
}

$head = &formatFoundHeader( $format, *PFields );         # Hidden ??
formatFoundSeparators( $format, 1 );

print <<EOM;
<form action="$SCRIPT/BasketEdit" target="_self">	
<div class="RECORDS"> $t0 $head
EOM
$i = 0;
foreach $_ (@list) {
print "$t1$_$t2";
$i++;
last if $i eq $max;
}
print $t3;

$modify = "Add checked items to $WBB{'basketName'}";    #UK
$x      = 'SUBMIT';
$x      = 'HIDDEN' unless $WBB{'basketName'};
print <<EOM;
</div>
<br>
<input $x class="BUTTON" type="$x" value="$modify">
</form>
EOM
}


sub formatFoundHeader {

local ( $format, *fields ) = @_;
local ( $f, $hd, $ft );

@fields = &visibleFields(@fields);

if ( $format eq 'TABLE' ) {
$hd = '<tr class="DATAH" ><th>&nbsp;</th>' . "\n";
}
else {
$hd = '';
}

foreach $f (@fields) {
if ( $format eq 'TABLE' ) {
$x = &formatFieldName($f);
$hd .= '<th align="left">' . $x . '</th>';
}
elsif ( $format eq 'TAB' ) {
$hd .= "$f\t";
}
elsif ( $format eq 'CSV' ) {
$hd .= "$f,";
}
elsif ( $format eq 'CSVS' ) {
$hd .= "$f;";
}
}

if (   $format eq 'TAB'
|| $format eq 'CSV'
|| $format eq 'CSVS' )
{
chop($hd);
}

if ( $format eq 'TABLE' ) {
$hd .= "</tr>";
}

$hd .= "\n" if $hd ne '';

return $hd;
}


sub formatFoundSeparators {

local ( $format, $n ) = @_;

if ( $format eq 'CSV' || $format eq 'CSVS' ) {
$t0 = "";
$t1 = "";
$t2 = "\n";
$t3 = "";
}
elsif ( $format eq 'TAB' ) {
$t0 = "<XMP>\n";
$t1 = "";
$t2 = "\n";
$t3 = "</XMP>\n";
}
elsif ( $format eq 'RAW' ) {
$t0 = "";
$t1 = "";
$t2 = "\n";
$t3 = "";
}
elsif ( $format eq 'XML' || $format eq 'XMLE' ) {
$t0 = "<!DOCTYPE records>\n<records>\n";
$t1 = "";
$t2 = "";
$t3 = "</records>\n";
}
elsif ( $format eq 'RSS' ) {
$x  = &htUntag("$WBB{'apTitle'} - $WBB{'dbTitle'}");
$x  = &htQuote($x);
$y  = &htQuote( $WBB{'about'} );
$t0 = <<EOM;
<rss version="0.91">
<channel>
<title>$x</title>
<link>$SCRIPTBASE$SCRIPT</link>
<description>$y</description>
<language>en-us</language>
EOM
$t1 = "";
$t2 = "";
$t3 = <<EOM;
</channel>
</rss>
EOM
}
elsif ( $format eq 'TABLE' ) {
$t0 = '<table class="DATATABLE" cellspacing="1">"\n"';
$t1 = "";
$t2 = "";
$t3 = "</table><br>\n";
}
elsif ( $format eq 'LONG' || $format eq 'NAMEVAL' ) {
$t0 = "";
$t1 = "";
$t2 = "<hr>\n";
$t3 = "";
}
elsif ( $format eq 'DEFAULT' || $format =~ m/^\d$/ ) {
$t0 = &evalMaybe( $WBB{"formatHead$format"} );
$t1 = '';
$t2 = '';
$t3 = &evalMaybe( $WBB{"formatFoot$format"} );
}
elsif ( $format eq 'PARAGRAPH' ) {
$t0 = '';
$t1 = '';
$t2 = '';
$t3 = '<br><br>';
}
}
1;
