

sub cgiOffice {

logDebug( $CGI{'XML'} );

if ( $ENV{'HTTP_SOAPACTION'} eq "urn:Microsoft.Search/Registration" ) {

officeRegistration();

}
elsif ( $ENV{'HTTP_SOAPACTION'} eq "urn:Microsoft.Search/Query" ) {

officeQuery();

}
else {

printHead("Office Research Task Pane");    #UK

print <<EOM;                               #UK
<p>
This application also acts as a Web Service feeding data into the 
<a href="http://office.microsoft.com/en-us/assistance/HP010002811033.aspx">Microsoft Office research task pane</A>.

<p>
To insert it into the Office environment, please follow
<a href="http://office.microsoft.com/en-us/assistance/HP010377881033.aspx">these instructions</A>.

<p>
For more information about Research Services in Microsoft Office browse
<a href="http://office.microsoft.com/en-us/assistance/CH010716751033.aspx">this list of articles</A>.

<p>
Here is the <a href="$SCRIPT/OfficeWSDL">WSDL</A> of this service.
EOM

}
}


sub officeRegistration {

$description = &htUntag( $WBB{'about'} );
$name        = &htUntag( $WBB{'apTitle'} . $WBB{'dbTitle'} );
$name =~ s/\s//g;

$provider = $WBB{'provider'} || $ENV{'SERVER_NAME'};
$license = $WBB{'license'}
|| 'This is a free service. You do not have to pay anything, anytime.';    #UK
$category = $WBB{'officeCategory'} || 'RESEARCH_GENERAL';

$string = <<EOM;
<ProviderUpdate xmlns='urn:Microsoft.Search.Registration.Response'>
<Status>SUCCESS</Status>
<Providers revision='2'>
<Provider action='UPDATE'>
<Message>
This is a WODA based service for Office 2003, provided by $provider. 
</Message>
<License acceptRequired='true'><LicenseText>$license</LicenseText></License>
<Id>{C818DC43-F71C-11d6-9039-00B0D019A5D1}</Id>
<Name>$provider</Name>
<QueryPath>$SCRIPTBASE$SCRIPT/Office</QueryPath>
<RegistrationPath>$SCRIPTBASE$SCRIPT/Office</RegistrationPath>
<Type>SOAP</Type>
<AboutPath>$SCRIPTBASE$SCRIPT/About</aboutPath>
<Revision>2</Revision>
<Services>
<Service>
<Id>{C818DC43-F71C-11d6-9039-00B0D019A5D1}</Id>
<Name>$name</Name>
<Description>$description</Description>
<AboutPath>$SCRIPTBASE$SCRIPT/About</aboutPath>
<Copyright>Copyright (c) $provider.  All Rights Reserved.</Copyright>
<TermsOfUsePath>$SCRIPTBASE$SCRIPT/About</TermsOfUsePath>
<Display>On</Display>
<Category>$category</Category>
<Parental>Unsupported</Parental>
</Service>
</Services>
</Provider>
</Providers>
</ProviderUpdate>
EOM

$string = &htQuote($string);

$string = <<EOM;
<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
<soap:Body>
<RegistrationResponse xmlns="urn:Microsoft.Search">
<RegistrationResult>$string</RegistrationResult>
</RegistrationResponse>
</soap:Body>
</soap:Envelope>	
EOM

$len = length($string);
binmode(STDOUT);
print "Content-type: text/xml; charset=utf-8\nContent-Length: $len\n\n$string";

}


sub logDebug {

local ($x);

open( h, ">>$DATADIR/_log/debug.log" );
binmode(h);

print h "--- request ------------------------------------------\n";
foreach $x ( sort( keys(%ENV) ) ) {
print h "$x=$ENV{$x}\n";
}
print h $_[0];

close(h);

}


sub officeQuery {

$CGI{'xml'} =~ m|([^;]*)\&lt\;/QueryText|;
$search = $1;

local (@list);

( $allHits, *list, *fields ) = &recSelect( '', $search, 'DEFAULT', 'DEFAULT' );
$dataHits = $#list + 1;

$string = <<EOM;
<ResponsePacket revision="1" xmlns="urn:Microsoft.Search.Response">
<Response domain="{C818DC43-F71C-11D6-9039-00B0D019A5D1}">
<Range>
<StartAt>1</StartAt>
<Count>$dataHits</Count>
<TotalAvailable>$allHits</TotalAvailable>
<Results>
<Content xmlns="urn:Microsoft.Search.Response.Content">
<Image source="$SCRIPTBASE$ICONURL/poweredby.gif"/>
EOM

foreach $hit (@list) {

$hit =~ s/\n/ /g;
$hit =~ m|_id\=([^\&]+)|i;
$url = "$SCRIPTBASE$SCRIPT/Show?_id=$1";

$hit = &htUntag($hit);

$hit =~ s/^[\s\d\.]+//g;

$hit =~ s/&nbsp;//g;
$hit =~ s/[ \t]+/ /g;
$hit =~ s/\n+/ /g;
$hit =~ s/^\s*//g;

$hit =~ m/\(/;
$title = $`;

$string .= <<EOM;
<Heading collapsible="true">
<Text>$title</Text>
<p>$hit</p>
<Hyperlink url="$url">
<Text> more </Text>
</Hyperlink>
</Heading>
EOM

}

$string .= <<EOM;
<HorizontalRule/>
<Hyperlink url="$SCRIPTBASE$SCRIPT/Search?search=$search">
<Text>Continue your search in Browser ...</Text>
</Hyperlink>
</Content>
</Results>
</Range>
<Status>SUCCESS</Status>
</Response>
</ResponsePacket>
EOM

$string = &htQuote($string);
$string =~ &htUTF8($string);

$string = <<EOM;
<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
<soap:Body>
<QueryResponse xmlns="urn:Microsoft.Search">
<QueryResult>$string</QueryResult>
</QueryResponse>
</soap:Body>
</soap:Envelope>
EOM

$len = length($string);
binmode(STDOUT);
print "Content-type: text/xml; charset=utf-8\nContent-Length: $len\n\n$string";
}
1;
