


exportService( 'XmlApi', '', '', 'Returns XML API to this Web service.' );

exportService(
'Show', 'format,_id,fields',
'rec',  'Returns fields "fields" of record with id="_id". Format must be XML! "fields" is a comma separated list of field names.'
);

exportService(
'Search',
'search,format,fields',
'records',
'Returns "fields" of records matching the "search" criteria. 
Format must be equal to XML. search parameter has the same syntax as in the interactive Search request.'
);

exportService( 'Xput', '', '',
'Inserts name value pairs into the database. For example ..../Xput?name=Tom&amp;surname=Jones&amp;_id=45 would add Tom Jones as record with id=45.'
);

exportService( 'XputMany', '', '', 'Inserts the POSTed .csv file of content-type text/csv into the database.' );

exportService( 'Xget', 'id', '', 'Gets a complete record with given id in XMLish format.' );


sub cgiXmlApi {

printXmlHead();
$res = '';
foreach $key ( sort( keys(%ServiceIn) ) ) {
@ins = split( /,/, $ServiceIn{$key} );
$url = "$SCRIPTBASE$SCRIPT/$key?";

chop($url);
$url = &htQuote($url);
$res .= <<EOM;
<requestApi name="$key">
<url>$url</url>
<method>GET|POST</method>
<parameterEncoding>URLencoded</parameterEncoding>
EOM
foreach $in (@ins) {
$res .= "<parameter>$in</parameter>\n";
}
$res .= <<EOM;
<result>$ServiceRet{$key}</result>
<documentation>$ServiceDoc{$key}</documentation>
<seeAlso>$SCRIPTBASE$SCRIPT/HtmlApi</seeAlso>
</requestApi>
EOM
}
printXmlAction($res);
}


sub printXmlHead {
$e = $WBB{'intlCharset'} || 'UTF-8';
print $HTTP200OK;
print "Content-type: text/xml\n\n";
print <<EOM;
<?xml version="1.0" encoding="$e" standalone="yes" ?>
EOM
}


sub printXmlAction {

$result = $_[0];

print <<EOM;
<!DOCTYPE request>
<request name="$Page">
<in>
EOM

foreach $key ( keys(%CGI) ) {
next if $key eq '_isindex';
print "<$key>$CGI{$key}</$key>\n";
}

print <<EOM;
</in>
<out>$result</out>
</request>
EOM
}
1;
